//
//  JCMessageFrameModel.m
//  JCMessageQQ
//
//  Created by QB on 16/5/9.
//  Copyright © 2016年 JC. All rights reserved.
//

#import "JCMessageFrameModel.h"

#import "JCMessageModel.h"

#define markWidth [UIScreen mainScreen].bounds.size.width

@implementation JCMessageFrameModel


- (void)setModel:(JCMessageModel *)model {
    _model = model;
    
    //间隔
    CGFloat space = 10;
    //时间
    CGFloat timeX = 0;
    CGFloat timeY = timeX;
    CGFloat timeW = markWidth;
    CGFloat timeH = 30;
    if (!model.isHiddenTime) {
    self.timeFrame = CGRectMake(timeX, timeY, timeW, timeH);
    }
    //头像
    CGFloat iconW = 60;
    CGFloat iconH = 60;
    CGFloat iconY = CGRectGetMaxY(self.timeFrame) + space;
    CGFloat iconX;
    if (model.type == JCMessageModelTypeSelf) {
        iconX = markWidth - iconW - space;
    } else {
        iconX = space;
    }
    
    self.iconFrame = CGRectMake(iconX, iconY, iconW, iconH);
    //内容
    CGSize textSize = [self sizeWithNSString:model.text withFount:[UIFont systemFontOfSize:14.0] maxSize:CGSizeMake(markWidth - 160, MAXFLOAT)];
    CGSize buttonSize = CGSizeMake(textSize.width + 20 * 2, textSize.height + 20 * 2);
    CGFloat messageBtnY = iconY;
    CGFloat messageBrnX;
    if (model.type == JCMessageModelTypeSelf) {
        messageBrnX = markWidth - 2*space - iconW - buttonSize.width;
    } else {
        messageBrnX = CGRectGetMaxX(self.iconFrame) + space;
    }
    
    self.messageBtnFrame = CGRectMake(messageBrnX, messageBtnY, buttonSize.width, buttonSize.height);
    
    //计算好高
    CGFloat iconMaxY = CGRectGetMaxY(self.iconFrame);
    CGFloat messageBtnMaxY = CGRectGetMaxY(self.messageBtnFrame);
    self.rowHeight = MAX(iconMaxY, messageBtnMaxY) + space;
}


//计算行高
- (CGSize)sizeWithNSString:(NSString *)text withFount:(UIFont *)fount maxSize:(CGSize)maxSize {
    
    NSDictionary *dic = @{NSFontAttributeName:fount};
    
   CGSize size = [text boundingRectWithSize:maxSize options:NSStringDrawingUsesLineFragmentOrigin attributes:dic context:nil].size;
    
    return size;
}


@end
